/* SPDX-License-Identifier: LicenseRef-Fortinet */

// TODO: split each module into a separate .d.ts file or convert the .mjs files to .ts files.
declare module "fos-webui" {
  import { OEMGUIVisibilitySchema } from "fos-schema-types/api/v2/static/oem_gui_visibility.schema";
  export const fosWebuiReady: Promise<void>;
  export const BUILD: {
    // TODO: fill these in as they are used to help track what's actually being used.
    CONFIG: {
      CONFIG_GUI_NO: string | number;
      CONFIG_BUILD_NUMBER: string;
      CONFIG_CODE_COVERAGE: boolean;
      CONFIG_MAJOR_NUM: string;
      CONFIG_MINOR_NUM: string;
      CONFIG_PATCH_NUM: string;
      CONFIG_BRANCH_POINT: string;
      CONFIG_DEBUG: boolean;
    };
    PLATFORM: {
      CONFIG_BUILD_LABEL: string;
      ABBREV: string;
    };
    SYMBOLS: {
      // TODO: build these type definitions in build.js instead
      WIRELESS_MODE_WTP: number;
      WIRELESS_MODE_CLIENT: number;
      ROOT_VF_NAME: string;
      HA_STANDALONE: number;
      HA_AA: number;
      HA_AP: number;
      INVALID_SIGNATURE: string;
      LICENSE_STATUS_CLOUD_CONFIRM_EMAIL: string;
      LICENSE_STATUS_CLOUD_ERROR: string;
      LICENSE_STATUS_CLOUD_LOGGED_IN: string;
      LICENSE_STATUS_CLOUD_LOGGED_OUT: string;
      LICENSE_STATUS_CLOUD_LOGIN_IN_PROGRESS: string;
      LICENSE_STATUS_EXPIRED: string;
      LICENSE_STATUS_EXPIRES_SOON: string;
      LICENSE_STATUS_FREE_LICENSE: string;
      LICENSE_STATUS_FREE_LICENSE_EXHAUSTED: string;
      LICENSE_STATUS_LICENSED: string;
      LICENSE_STATUS_LICENSED_EXHAUSTED: string;
      LICENSE_STATUS_NOT_REGISTERED: string;
      LICENSE_STATUS_NO_LICENSE: string;
      LICENSE_STATUS_NO_SUPPORT: string;
      LICENSE_STATUS_PENDING: string;
      LICENSE_STATUS_REGISTERED: string;
      LICENSE_STATUS_TYPE_CLOUD_SERVICE: string;
      LICENSE_STATUS_TYPE_FDS_OBJECT: string;
      LICENSE_STATUS_TYPE_FORTIGUARD_SERVICE: string;
      LICENSE_STATUS_TYPE_PRODUCT_INTEGRATION: string;
      LICENSE_STATUS_VM_EVAL: string;
      LICENSE_STATUS_VM_EVAL_EXPIRED: string;
      LICENSE_STATUS_VM_EXPIRED: string;
      LICENSE_STATUS_VM_EXPIRES_SOON: string;
      LICENSE_STATUS_VM_INVALID: string;
      LICENSE_STATUS_VM_PENDING: string;
      LICENSE_STATUS_VM_VALID: string;
      LICENSE_STATUS_VM_VALIDATION_OVERDUE: string;
      LICENSE_STATUS_UNAVAILABLE: string;
      CFG_ER_FIRMWARE_NOT_SIGNED_NOT_CONFIRM: string;
      BIOS_SECURITY_LEVEL_1: number;
      BIOS_SECURITY_LEVEL_2: number;
      POE_STATUS_DELIVERING_POWER: string;
    };
    LIVE_RELOAD?: {
      SERVER_IP: string;
      SERVER_PORT: number;
    };
  };
  export const VISIBILITY: OEMGUIVisibilitySchema;
  import { AngularJSRoutePermissionObject } from "fos-webui/lib/route-config";
  export {
    ACCESS_GROUP,
    PERMISSION,
    VDOM_SCOPE,
    ADMIN_TYPE,
  } from "fos-common/fortigate/state";
  export {
    PermissionPairType,
    PermissionType,
    ScopeType,
  } from "fos-webui/lib/route-config";
  export const NG_ROUTE_CONFIG: {
    routes: AngularJSRoutePermissionObject[];
  };
}

declare module "fos-webui/app" {
  import { IModule, IAngularStatic } from "angular";
  export const app: IModule;
  export const angular: IAngularStatic;
}

declare module "fos-webui/translate" {
  export const translate: (key: string) => string;
}

declare module "fos-webui/firmware" {
  export interface Firmware {
    major: number;
    minor: number;
    patch: number;
    build: number;
  }
  export function isFirmwareUpdate(
    currentFirmware: Firmware,
    newFirmware: Firmware
  ): boolean;
  export function compareFirmware(
    firmware1: Firmware,
    firmware2: Firmware
  ): number;
}
declare module "fos-webui/topology-parser" {
  export * from "fos-webui/lib/topology-parser";
}
declare module "fos-webui/tree" {
  export * from "fos-webui/lib/tree";
}
declare module "fos-webui/uri";
